#include "types.h"
#include "mat.h"


template <typename T>
class NeuralNet
{
 public:
  NeuralNet( uint nLayer, uint const * innerLayerSizes );
  ~NeuralNet();

  // todo: NeuralNet(NeuralNet)

  void instruct( T const * in, T const * expected );
  void present( T const * in );
  void initRandom( T const &lo, T const &hi );
  void initFlat( T const & );
  void initStep();
  void dump();

  // [glc] takes three extra word, but who cares ? not me
  Mat<T>  *m_vs, *m_ys;
  unsigned int m_nLayers, *m_layersSizes;
  Mat<T> *m_weights;

};
