#include <iostream>
#include <fstream>
#include "NN.h"


int
main( int argc, char *argv[] )
{
  unsigned int const layerSizes[] = { 2, 4, 4 ,1 };

  unsigned int const nLayer( sizeof layerSizes / sizeof *layerSizes );
  NeuralNet<float> nnet( nLayer, layerSizes );

   nnet.initRandom( -1.0f, 1.0f );


  
  for( int i = 0; 1599 != i; ++i )
  {
    //    float  e[] = { random() % 2 ? 1.0f : - 1.0f ,
    //		random() % 2 ? 1.0f : - 1.0f };
    float  e[] = { random() % 2,
		   random() % 2, 1, 1};

    //float  o( ( 1.0f == e[0] ) && ( -1.0f == e[1] )
    //|| ( -1.0f == e[0] ) && ( 1.0f == e[1] ) );
    float  o( ( 1.0f == e[0] ) && ( .0f == e[1] )
	      || ( .0f == e[0] ) && ( 1.0f == e[1] ) );

    nnet.instruct( e, &o );
  }

  for( int i = 0; 199 != i; ++i )
  {
    float e[] = { random() % 2,
		  random() % 2, 1, 1 };
    nnet.present( e );
    float const o( nnet.m_ys[nLayer - 1][0][0] );

    std::cout << e[0] << ", " << e[1] << " -> " << o << std::endl;

    float aishaOutput;

    int I = 0;
  } 
  
  return 0;
}

